package dal

import (
	"context"

	"github.guxuan/haibei/internal/mods/activity/schema"
	"github.guxuan/haibei/pkg/errors"
	"github.guxuan/haibei/pkg/util"
	"gorm.io/gorm"
)

// Get questionnaire storage instance
func GetQuestionnaireDB(ctx context.Context, defDB *gorm.DB) *gorm.DB {
	return util.GetDB(ctx, defDB).Model(new(schema.Questionnaire))
}

// Defining the `Questionnaire` data access object.
type Questionnaire struct {
	DB *gorm.DB
}

// Query questionnaires from the database based on the provided parameters and options.
func (a *Questionnaire) Query(ctx context.Context, params schema.QuestionnaireQueryParam, opts ...schema.QuestionnaireQueryOptions) (*schema.QuestionnaireQueryResult, error) {
	var opt schema.QuestionnaireQueryOptions
	if len(opts) > 0 {
		opt = opts[0]
	}

	db := GetQuestionnaireDB(ctx, a.DB)

	var list schema.Questionnaires
	pageResult, err := util.WrapPageQuery(ctx, db, params.PaginationParam, opt.QueryOptions, &list)
	if err != nil {
		return nil, errors.WithStack(err)
	}

	queryResult := &schema.QuestionnaireQueryResult{
		PageResult: pageResult,
		Data:       list,
	}
	return queryResult, nil
}

// Get the specified questionnaire from the database.
func (a *Questionnaire) Get(ctx context.Context, id uint, opts ...schema.QuestionnaireQueryOptions) (*schema.Questionnaire, error) {
	var opt schema.QuestionnaireQueryOptions
	if len(opts) > 0 {
		opt = opts[0]
	}

	item := new(schema.Questionnaire)
	ok, err := util.FindOne(ctx, GetQuestionnaireDB(ctx, a.DB).Where("id=?", id), opt.QueryOptions, item)
	if err != nil {
		return nil, errors.WithStack(err)
	} else if !ok {
		return nil, nil
	}
	return item, nil
}

// Exists checks if the specified questionnaire exists in the database.
func (a *Questionnaire) Exists(ctx context.Context, id uint) (bool, error) {
	ok, err := util.Exists(ctx, GetQuestionnaireDB(ctx, a.DB).Where("id=?", id))
	return ok, errors.WithStack(err)
}

// Create a new questionnaire.
func (a *Questionnaire) Create(ctx context.Context, item *schema.Questionnaire) error {
	result := GetQuestionnaireDB(ctx, a.DB).Create(item)
	return errors.WithStack(result.Error)
}

// Update the specified questionnaire in the database.
func (a *Questionnaire) Update(ctx context.Context, item *schema.Questionnaire) error {
	result := GetQuestionnaireDB(ctx, a.DB).Where("id=?", item.ID).Select("*").Omit("created_at").Updates(item)
	return errors.WithStack(result.Error)
}

// Delete the specified questionnaire from the database.
func (a *Questionnaire) Delete(ctx context.Context, id uint) error {
	result := GetQuestionnaireDB(ctx, a.DB).Where("id=?", id).Delete(new(schema.Questionnaire))
	return errors.WithStack(result.Error)
}
